#! /usr/bin/perl


$mylinkso=0;
$mylinkso=1 if ($ARGV[0] eq "shared");

$libs="";
$syst=`uname -s`;
$mysavail=-f "Ferret.xs";

$libs='-lg\+\+ -lgdbm' if $syst =~ m/linux/i;


if ($mysavail) {
	my @dir=split(/:/,$ENV{PATH});
	my @cpp=qw(g++ c++ CC);
	unshift @cpp,$ENV{CPP}			if $ENV{CPP};
	unshift @cpp,$ENV{CPLUSPLUS}	if $ENV{CPLUSPLUS};

	$mycpp="";
	CPP: foreach $cpp (@cpp) {
		if ($cpp =~ m|^/|) {
			if (-x $cpp) {
				$mycpp = "$cpp";
				last CPP;
			}
		}

		DIR: foreach $dir (@dir) {
			$file = "$dir/$cpp";
			if (-x $file) {
				$mycpp = "$file";
				last CPP;
			}
		}
	}

	die "Error: Could not locate C++ compiler -- Set the CPLUSPLUS env-var and try again\n" unless $mycpp;
#	print "C++ compiler: $mycpp\n";
}


undef %mminfo;
$mminfo{NAME}			= 'Ferret';
$mminfo{VERSION_FROM}	= 'Ferret.pm';
$mminfo{OBJECT}			= 'Ferret$(OBJ_EXT)';
$mminfo{EXE_FILES}		= [qw(bin/ferret bin/webscan)];
$mminfo{LIBS}			= [$libs] if $mylinkso;
$mminfo{INST_ARCHLIB}	= '$(INST_LIB)';
$mminfo{MAN1PODS}		= {
	'bin/ferret.pl'		=> '$(INST_MAN1DIR)/ferret.1',
	'bin/webscan.pl'	=> '$(INST_MAN1DIR)/webscan.1',
};
$mminfo{MAN3PODS}		= {
	'flibdoc'			=> '$(INST_MAN3DIR)/ferret.3',
};

if ($mylinkso) {
	$mminfo{OBJECT}	   .= ' ferret/libferret$(LIB_EXT)';
} else {
	$mminfo{OBJECT}	   .= ' ferret/libferret$(OBJ_EXT)';
}

if ($mysavail) {
	$mminfo{DEFINE}		= '-Dexplicit="" ';
	$mminfo{CC}			= $mycpp;
}


use ExtUtils::MakeMaker;
# See lib/ExtUtils/MakeMaker.pm for details of how to influence
# the contents of the Makefile that is written.
WriteMakefile(%mminfo);


sub MY::postamble {
'
$(MYEXTLIB): ferret/Makefile
	cd ferret && $(MAKE)

realclean ::
	rm -f bin/ferret bin/webscan


bin/ferret: bin/ferret.pl
	@rm -f $@
	$(PERL) -e \'undef $$/; $$_=<>; s|^.*?\n|\#\! $(PERL)\n|; s/^use\s*lib.*blib.*\n//m; s/\n=.*?(\n=cut.*?\n\s*|$$)/\n/sg; print $$_\' $? > $@
	@chmod 755 $@

bin/webscan: bin/webscan.pl
	@rm -f $@
	$(PERL) -e \'undef $$/; $$_=<>; s|^.*?\n|\#\! $(PERL)\n|; s/^use\s*lib.*blib.*\n//m; s/\n=.*?(\n=cut.*?\n\s*|$$)/\n/sg; print $$_\' $? > $@
	@chmod 755 $@

flibdoc:
	for i in dist/makelibdoc Ferret.pm ferret/flibdoc; do if [ ! -r $$i ]; then touch $@; exit 0; fi; done
	@rm -f $@
	$(PERL) dist/makelibdoc Ferret.pm ferret/flibdoc >$@
	@chmod 644 $@
'
}
